import { __decorate, __extends, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent';
import { DetailsColumn } from '../DetailsColumn';
import { classNamesFunction } from '@uifabric-vue/utilities';
var getClassNames = classNamesFunction();
var DetailsHeaderBase = /** @class */ (function (_super) {
    __extends(DetailsHeaderBase, _super);
    function DetailsHeaderBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DetailsHeaderBase.prototype, "classNames", {
        get: function () {
            var _a = this, styles = _a.styles, theme = _a.theme, className = _a.className;
            return getClassNames(styles, {
                theme: theme,
                isAllSelected: false,
                isSelectAllHidden: false,
                isResizingColumn: false,
                isSizing: false,
                isAllCollapsed: false,
                isCheckboxHidden: false,
                className: className,
            });
        },
        enumerable: false,
        configurable: true
    });
    DetailsHeaderBase.prototype.render = function () {
        var _this = this;
        var _a = this, classNames = _a.classNames, columns = _a.columns;
        return (<div class={classNames.root} role="row">
        {columns.map(function (column, index) { return (<DetailsColumn key={column.key} column={column} columnIndex={index} parentId={_this.uid}/>); })}
      </div>);
    };
    __decorate([
        Prop({ type: Array, required: true }),
        __metadata("design:type", Array)
    ], DetailsHeaderBase.prototype, "columns", void 0);
    DetailsHeaderBase = __decorate([
        Component({
            components: { DetailsColumn: DetailsColumn },
        })
    ], DetailsHeaderBase);
    return DetailsHeaderBase;
}(BaseComponent));
export { DetailsHeaderBase };
//# sourceMappingURL=DetailsHeader.base.jsx.map