import { __assign, __rest } from "tslib";
import { concatStyleSetsWithProps } from '@uifabric/merge-styles';
import Vue from 'vue';
import { Customizations } from '@uifabric-vue/utilities';
import { getTheme, registerOnThemeChangeCallback } from '@uifabric/styling';
var DefaultFields = ['theme', 'styles'];
export function styled(Component, baseStyles, getProps, customizable, pure) {
    customizable = customizable || { scope: '', fields: undefined };
    var scope = customizable.scope, _a = customizable.fields, fields = _a === void 0 ? DefaultFields : _a;
    var _styles;
    return Vue.extend({
        name: "Styled" + (Component.displayName || Component.name),
        props: typeof Component === 'function'
            ? Component.options.props
            : Component.props,
        data: function () {
            return {
                internalTheme: getTheme(),
            };
        },
        created: function () {
            var _this = this;
            registerOnThemeChangeCallback(function (theme) {
                _this.internalTheme = theme;
            });
        },
        render: function (h) {
            var _this = this;
            var settings = Customizations.getSettings(fields, scope);
            var customizedStyles = settings.styles, dir = settings.dir, rest = __rest(settings, ["styles", "dir"]);
            var additionalProps = getProps ? getProps(this) : undefined;
            if (!_styles || customizedStyles !== _styles.__cachedInputs__[1] || !!this.styles) {
                _styles = function (styleProps) { return concatStyleSetsWithProps(styleProps, baseStyles, _this.styles); };
                _styles.__cachedInputs__ = [baseStyles, this.styles];
            }
            return h(Component, {
                on: this.$listeners,
                attrs: this.$attrs,
                props: __assign(__assign(__assign(__assign(__assign({}, rest), additionalProps), this.$attrs), this.$props), { theme: this.internalTheme, className: this.className || this.$attrs.class || this.$vnode.data.class, styles: _styles }),
                scopedSlots: this.$scopedSlots,
            }, this.$slots.default);
        },
    });
}
//# sourceMappingURL=styled.js.map